#!/usr/bin/perl
#
# $Date: 2007-12-27 12:42:22 $ , $Revision: 1.8 $
# (c) Ruedi Hofer
#
use strict;
use warnings;
use Tk;
use Tk::JPEG;
use Tk::Photo;

# Input checken
if ( $#ARGV == -1 ) {
  print "Usage: name <files...>\n\n";
  print "GUI tool to change the 'title'-part of the filename and the file order conveniently.\n";
  print "The tool assumes filenames in the form 0000_YYMMDD_HHMM_title.jpg, generated by 'renameImage.pl'.\n\n";
  exit 0;
}
my $verbose = 1;
my $text;
my $textouttop = "";
my $entry;
my $title      = "";
my $titleLabel = "";
my $img1Label  = "";
my $img2Label  = "";
my $img3Label  = "";
my $fileout;
my $i = 0, my $j = 0;


#FRAMES
my $main       = MainWindow->new();
my $pxx        = 400;
my $pxy        = 400;
my $subsample1 = $main->Photo();
my $subsample2 = $main->Photo();
my $subsample3 = $main->Photo();
my $imgPrev    = $main->Frame()->pack( -side => 'top', -anchor => 'nw', -expand => 'yes' );
my $img1Prev   = $imgPrev->Frame()->pack( -side => 'left', -anchor => 'nw', -expand => 'yes' );
my $img1       = $img1Prev->Button(-command => \&actionShowPrevious )->pack( -side => 'top', -anchor => 'w' );
$img1Prev->Label( -textvariable => \$img1Label )->pack( -side => 'top' );
my $img2Prev = $imgPrev->Frame()->pack( -side => 'left', -anchor => 'nw', -expand => 'yes' );
my $img2 = $img2Prev->Button( -command => \&showImageInViewer )->pack( -side => 'top', -anchor => 'w' );
$img2Prev->Label( -textvariable => \$img2Label )->pack( -side => 'top' );
my $img3Prev = $imgPrev->Frame()->pack( -side => 'left', -anchor => 'nw', -expand => 'yes' );
my $img3 = $img3Prev->Button(-command => \&actionShowNext )->pack( -side => 'top', -anchor => 'w' );
$img3Prev->Label( -textvariable => \$img3Label )->pack( -side => 'top' );

my $empty          = $main->Photo(qw/-width 400 -height 400/);
$empty->put(qw/black          -to  0  0 400 400/);
  
#Top Frame erstellen
my $top = $main->Frame()->pack( -side => 'top', -anchor => 'nw', -expand => 'yes' );
my $topleft = $top->Frame()->pack( -side => 'left', -anchor => 'w' );
my $label = $topleft->Label( -textvariable => \$textouttop, -background => "yellow" )->pack( '-side' => 'left' );
my $topright = $top->Frame()->pack( -side => 'left', -anchor => 'e' );
$text = $topright->Label( -textvariable => \$titleLabel )->pack( -side => 'left' );
$entry = $topright->Entry( -textvariable => \$title, -width => 35 )->pack( -side => 'left' );
my $buttonRename = $topright->Button( -text => 'Rename', -command => \&actionRename )->pack( '-side' => 'left' );
my $buttonClear  = $topright->Button( -text => 'Clear',  -command => \&actionClear )->pack( '-side'  => 'left' );

#Output bottom Frame erstellen
my $outputbottom = $main->Frame()->pack( -side => 'top', -anchor => 'w' );
my $log = $outputbottom->Text( -width => 150, -height => 8 )->pack( -side => 'left' );
my $logScrollbar = $outputbottom->Scrollbar( -command => [ yview => $log ] )->pack( -side => 'left', -fill => 'y' );
$log->configure( -yscrollcommand => [ set => $logScrollbar ] );

#Input bottom Frame erzeugen
my $inputbottom = $main->Frame()->pack( -side => 'bottom', -anchor => 'se' );
my $buttonDelete   = $inputbottom->Button( -text => 'Delete',    -command => \&actionDelete )->pack( '-side'   => 'left' );
my $buttenRotLeft  = $inputbottom->Button( -text => 'Rot left',  -command => \&actionRotLeft )->pack( '-side'  => 'left' );
my $buttenRotRight = $inputbottom->Button( -text => 'Rot right', -command => \&actionRotRight )->pack( '-side' => 'left' );
$inputbottom->Label( -text => " " )->pack( -side => 'left' );
my $buttonMoveBack = $inputbottom->Button( -text => 'Move back', -command => \&actionMoveBack )->pack( '-side' => 'left' );
my $rbMoveVal = '1';
$inputbottom->Radiobutton(
  -text     => '1',
  -variable => \$rbMoveVal,
  -value    => '1'
)->pack( '-side' => 'left' );
$inputbottom->Radiobutton(
  -text     => '10',
  -variable => \$rbMoveVal,
  -value    => '10'
)->pack( '-side' => 'left' );
my $buttonMoveFwd = $inputbottom->Button( -text => 'Move fwd', -command => \&actionMoveFwd )->pack( '-side' => 'left' );
$inputbottom->Label( -text => " " )->pack( -side => 'left' );
my $buttonShowPrev = $inputbottom->Button(
  -text    => 'Show Prev',
  -command => \&actionShowPrevious
)->pack( '-side' => 'left' );
my $rbShowVal = '1';
$inputbottom->Radiobutton(
  -text     => '1',
  -variable => \$rbShowVal,
  -value    => '1'
)->pack( '-side' => 'left' );
$inputbottom->Radiobutton(
  -text     => '10',
  -variable => \$rbShowVal,
  -value    => '10'
)->pack( '-side' => 'left' );
my $buttonShowNext = $inputbottom->Button( -text => 'Show Next', -command => \&actionShowNext )->pack( '-side' => 'left' );
$inputbottom->Label( -text => " " )->pack( -side => 'left' );
my $buttonQuit = $inputbottom->Button( -text => 'Quit', -command => \&actionQuit )->pack( '-side' => 'left' );
$log->insert( 'end', "Logfile:\n" );
nextImage();

#ACTION
sub actionRename {
  $ARGV[$i] =~ /(.*)(\/*)(\d\d\d\d)_(\d\d\d\d\d\d)_(\d\d\d\d)_(.*)\.(.*)$/;
  if ( $7 && ( $7 eq "gif" || $7 eq "jpg" ) ) {
    $fileout = sprintf "%s%s%s_%s_%s_%s.%s", $1, $2, $3, $4, $5, $title, $7;
  }
  $ARGV[$i] =~ /(.*)(\/*)(\d\d\d\d)_(.*)\.(.*)$/;
  if ( $5 && ( $5 eq "wav" || $5 eq "avi" ) ) {
    $fileout = sprintf "%s%s%s_%s.%s", $1, $2, $3, $title, $5;
  }
  logText( sprintf "#%i: move %s => %s", $i, $ARGV[$i], $fileout );
  rename $ARGV[$i], $fileout;

  # adjust preview label
  $img2Label = $fileout;

  # für den Prvious Knopf
  $ARGV[$i] = $fileout;
  checkEnd();
  nextImage();
}

sub actionClear {
  $title =~ /(.*)(_)(.*)/;
  if ($2) {
    if ($3) {
      $title =~ s/(.*)(_)(.*)/$1$2/g;
    } else {
      $title =~ s/(.*)(_)(.*)/$1/g;
    }
  } else {
    $title = '';
  }
}

sub actionShowNext {
  checkEnd();
  nextImage();
}

sub actionShowPrevious {
  if ( $i >= $rbShowVal ) {
    $i -= $rbShowVal;
  }
  nextImage();
}

sub actionMoveBack {
  if ( $i >= $rbMoveVal ) {
    for ( my $j = 0 ; $j < $rbMoveVal ; $j++ ) {
      exchangeImage(-1);
      $i--;
    }
    nextImage();
  }
}

sub actionMoveFwd {
  if ( $i + $rbMoveVal <= $#ARGV ) {
    for ( my $j = 0 ; $j < $rbMoveVal ; $j++ ) {
      $i++;
      exchangeImage(-1);
    }
    nextImage();
  }
}

sub actionDelete {
  $ARGV[$i] =~ /(.*\/|^)(\/*)(.*)$/;
  my $tmp1 = sprintf "%s%strash/%s", $1, $2, $3;
  my $tmp2 = sprintf "%s%strash/", $1, $2;
  mkdir $tmp2;
  rename $ARGV[$i], $tmp1;
  logText( sprintf "#%i: remove %s => %s", $i, $ARGV[$i], $tmp1 );
  splice( @ARGV, $i, 1 );
  if ( $i > $#ARGV ) {
    $i--;
  }
  nextImage();
}

sub actionRotLeft {
  my $tmp1 = $ARGV[$i];
  $tmp1 =~ /(.*\/|^)(\/*)(\d\d\d\d)_(.*)$/;
  my $tmp3 = sprintf "%s%stmp", $1, $2;
  system "/usr/bin/jpegtran -rotate 270 -copy all $ARGV[$i] > $tmp3";
  rename $tmp3, $tmp1;
  logText( sprintf "#%i: Rotate Left %s", $i, $ARGV[$i] );
  if ( $i > $#ARGV ) {
    $i--;
  }
  nextImage();
}

sub actionRotRight {
  my $tmp1 = $ARGV[$i];
  $tmp1 =~ /(.*\/|^)(\/*)(\d\d\d\d)_(.*)$/;
  my $tmp3 = sprintf "%s%stmp", $1, $2;
  system "/usr/bin/jpegtran -rotate 90 -copy all $ARGV[$i] > $tmp3";
  rename $tmp3, $tmp1;
  logText( sprintf "#%i: Rotate Right %s", $i, $ARGV[$i] );
  if ( $i > $#ARGV ) {
    $i--;
  }
  nextImage();
}

sub actionQuit {
  print "fertig ...\n";
  killHelper();
  $main->destroy();
}

#HELPER
sub exchangeImage () {
  my $offset = shift;
  my $tmp1   = $ARGV[$i];
  my $tmp2   = $ARGV[ $i + $offset ];
  $tmp1 =~ /(.*\/|^)(\/*)(\d\d\d\d)_(.*)$/;
  my $nbr1 = $3;
  my $tmp3 = sprintf "%s%stmp", $1, $2;
  $tmp2 =~ /(.*\/|^)(\/*)(\d\d\d\d)_(.*)$/;
  my $nbr2 = $3;
  $tmp1 =~ s/(.*\/|^)(\/*)(\d\d\d\d)_(.*)$/$1$2$nbr2\_$4/g;
  $tmp2 =~ s/(.*\/|^)(\/*)(\d\d\d\d)_(.*)$/$1$2$nbr1\_$4/g;
  logText( sprintf "#%i: move %s => %s", $i, $ARGV[$i], $tmp1 );
  logText( sprintf "#%i: move %s => %s", $i, $ARGV[ $i + $offset ], $tmp2 );
  rename $ARGV[$i], $tmp3;
  rename $ARGV[ $i + $offset ], $tmp2;
  rename $tmp3, $tmp1;
  $ARGV[$i] = $tmp2;
  $ARGV[ $i + $offset ] = $tmp1;
}

sub logText {
  my $text = shift;
  $log->insert( 'end', "$text\n" );
}

sub showImage {
  my $i              = shift;
  my $subsample1temp = $main->Photo();
  $subsample1temp->copy($subsample1);
  my $subsample2temp = $main->Photo();
  $subsample2temp->copy($subsample2);
  my $subsample3temp = $main->Photo();
  $subsample3temp->copy($subsample3);

  $img2->configure( -image => $empty );
  if (!($ARGV[$i]=~ m/.*(jpg|jpeg|gif)/)) {
    $img2->configure( -image => "" );
    $img2->configure( -text => "No Pic" );
  } elsif ( $ARGV[$i] eq $img3Label ) {
    $subsample2->copy($subsample3temp);
    $img2->configure( -image => $subsample2 );
    print "move img 3 to 2\n" if $verbose;
  } elsif ( $ARGV[$i] eq $img1Label ) {
    $subsample2->copy($subsample1temp);
    $img2->configure( -image => $subsample2 );
    print "move img 1 to 2\n" if $verbose;
  } else{
    print "resize img 2\n" if $verbose;
    my $photo = $main->Photo( -file => $ARGV[$i] );
    my ( $w, $h ) = ( $photo->width, $photo->height );
    my $sw = $pxx == -1 ? 1 : ( $w / $pxx );
    my $sh = $pxy == -1 ? 1 : ( $h / $pxy );
    if ( $sw > $sh ) { $sh = $sw }
    if ( $sh > $sw ) { $sw = $sh }
    if ( $sw >= 1 and $sh >= 1 ) {
      $subsample2->copy( $photo, -subsample => ( $sw, $sh ) );
    } else {
      $subsample2->copy( $photo, -zoom => ( 1 / $sw, 1 / $sh ) );
    }
    print $photo->width . " " . $photo->height . " $sw $sh\n" if $verbose;
    $photo->delete();
    $img2->configure( -image => $subsample2 );
  }
  if ( $i > 0 ) {
    $img1->configure( -image => $empty );
    if (!($ARGV[$i-1]=~ m/.*(jpg|jpeg|gif)/)) {
      $img1->configure( -image => "" );
      $img1->configure( -text => "No Pic" );
    } elsif ( $ARGV[ $i - 1 ] eq $img2Label ) {
      $subsample1->copy($subsample2temp);
      $img1->configure( -image => $subsample1 );
      $img1->configure( -state => "normal" );
      print "move img 2 to 1\n" if $verbose;
    } else {
      print "resize img 1\n" if $verbose;
      my $photo = $main->Photo( -file => $ARGV[ $i - 1 ] );
      my ( $w, $h ) = ( $photo->width, $photo->height );
      my $sw = $pxx == -1 ? 1 : ( $w / $pxx );
      my $sh = $pxy == -1 ? 1 : ( $h / $pxy );
      if ( $sw > $sh ) { $sh = $sw }
      if ( $sh > $sw ) { $sw = $sh }
      if ( $sw >= 1 and $sh >= 1 ) {
        $subsample1->copy( $photo, -subsample => ( $sw, $sh ) );
      } else {
        $subsample1->copy( $photo, -zoom => ( 1 / $sw, 1 / $sh ) );
      }
      print $photo->width . " " . $photo->height . " $sw $sh\n" if $verbose;
      $photo->delete();
      $img1->configure( -image => $subsample1 );
      $img1->configure( -state => "normal" );
    }
  } else {
    $subsample1->copy($subsample2);
    $img1->configure( -image => $subsample1 );
    $img1->configure( -state => "disabled" );
    print "first img in queue for 1\n" if $verbose;
  }
  if ( $#ARGV >= $i + 1 ) {
    $img3->configure( -image => $empty );
    if (!($ARGV[$i+1]=~ m/.*(jpg|jpeg|gif)/)) {
      $img3->configure( -image => "" );
      $img3->configure( -text => "No Pic" );
    } elsif ( $ARGV[ $i + 1 ] eq $img2Label ) {
      $subsample3->copy($subsample2temp);
      $img3->configure( -image => $subsample3 );
      $img3->configure( -state => "normal" );
      print "move img 2 to 3\n" if $verbose;
    } else {
      print "resize img 3\n" if $verbose;
      my $photo = $main->Photo( -file => $ARGV[ $i + 1 ] );
      my ( $w, $h ) = ( $photo->width, $photo->height );
      my $sw = $pxx == -1 ? 1 : ( $w / $pxx );
      my $sh = $pxy == -1 ? 1 : ( $h / $pxy );
      if ( $sw > $sh ) { $sh = $sw }
      if ( $sh > $sw ) { $sw = $sh }
      if ( $sw >= 1 and $sh >= 1 ) {
        $subsample3->copy( $photo, -subsample => ( $sw, $sh ) );
      } else {
        $subsample3->copy( $photo, -zoom => ( 1 / $sw, 1 / $sh ) );
      }
      print $photo->width . " " . $photo->height . " $sw $sh\n" if $verbose;
      $photo->delete();
      $img3->configure( -image => $subsample3 );
      $img3->configure( -state => "normal" );
    }
  } else {
    $subsample3->copy($subsample2);
    $img3->configure( -image => $subsample3 );
    $img3->configure( -state => "disabled" );
    print "last img in queue for 3\n" if $verbose;
  }
  if ( $i > 0 ) {
    $img1Label = $ARGV[ $i - 1 ];
  } else {
    $img1Label = "";
  }
  $img2Label = $ARGV[$i];
  if ( $#ARGV >= $i + 1 ) {
    $img3Label = $ARGV[ $i + 1 ];
  } else {
    $img3Label = "";
  }
  $subsample1temp->delete();
  $subsample2temp->delete();
  $subsample3temp->delete();
}

sub showImageInViewer {
  if ($ARGV[$i]=~ m/.*(jpg|jpeg|gif)/) {
    system "display -size 400x400 $ARGV[$i] &";
  } else {
    system "/usr/bin/xine $ARGV[$i] &";
  }
}

sub nextImage {

  #display image
  killHelper();
  showImage($i);
  $ARGV[$i] =~ /(.*)(\/*)(\d\d\d\d)_(\d\d\d\d\d\d)_(\d\d\d\d)_(.*)\.(.*)$/;
  if ( $7 && ( $7 eq "gif" || $7 eq "jpg" ) ) {
    $textouttop = sprintf "#%i: %s", $i, $ARGV[$i];    
    if ( $6 eq "title" ) {
      $titleLabel = "Previous Title";
    } else {
      $titleLabel = "Current Title";
      $title      = $6;
    }
  }
  $ARGV[$i] =~ /(.*)(\/*)(\d\d\d\d)_(.*)\.(.*)$/;
  if ( $5 && ( $5 eq "wav" || $5 eq "avi" ) ) {
    $textouttop = sprintf "Next item:\n#%i: %s", $i, $ARGV[$i];
    if ( $4 eq "title" ) {
      $titleLabel = "Previous Title";
    } else {
      $titleLabel = "Current Title";
      $title      = $4;
    }
  }
}

sub checkEnd {
  if ( $#ARGV < $i + $rbShowVal ) {
    return 1;
  }
  $i += $rbShowVal;
  return 0;
}

sub killHelper {
  system "killall -q display";
  system "killall -q xine";
}

#MainLoop ausführen
MainLoop();
